import{s as Te,n as _e,o as ve}from"../chunks/scheduler.0f20f9e5.js";import{S as Le,i as Me,g as o,s as n,r as P,A as Ce,h as l,f as i,c as s,j as $e,u as z,x as r,k as we,y as He,a,v as A,d as B,t as J,w as R}from"../chunks/index.fbd8b8e3.js";import{C as xe}from"../chunks/CodeBlock.c14486c2.js";import{H as k}from"../chunks/Heading.2451f3bb.js";function Pe(oe){let f,X,q,Z,p,F,m,le="With Transformers it’s very easy to load any model in 4 or 8-bit, quantizing them on the fly with bitsandbytes primitives.",I,c,re='Please review the <a href="https://huggingface.co/docs/transformers/v4.37.2/en/quantization#bitsandbytes" rel="nofollow">bitsandbytes section in the Accelerate docs</a>.',j,d,fe='Details about the BitsAndBytesConfig can be found <a href="https://huggingface.co/docs/transformers/v4.37.2/en/main_classes/quantization#transformers.BitsAndBytesConfig" rel="nofollow">here</a>.',Q,u,U,b,pe="If your hardware supports it, <code>bf16</code> is the optimal compute dtype. The default is <code>float32</code> for backward compatibility and numerical stability. <code>float16</code> often leads to numerical instabilities, but <code>bfloat16</code> provides the benefits of both worlds: numerical stability and significant computation speedup. Therefore, be sure to check if your hardware supports <code>bf16</code> and configure it using the <code>bnb_4bit_compute_dtype</code> parameter in BitsAndBytesConfig:",N,h,S,g,V,y,me="With <code>PEFT</code>, you can use QLoRA out of the box with <code>LoraConfig</code> and a 4-bit base model.",W,$,ce='Please review the <a href="https://huggingface.co/docs/peft/developer_guides/quantization#quantize-a-model" rel="nofollow">bitsandbytes section in the Accelerate docs</a>.',G,w,Y,T,de="Bitsandbytes is also easily usable from within Accelerate.",D,_,ue='Please review the <a href="https://huggingface.co/docs/accelerate/en/usage_guides/quantization" rel="nofollow">bitsandbytes section in the Accelerate docs</a>.',K,v,O,L,be="You can use any of the 8-bit and/or paged optimizers by simple passing them to the <code>transformers.Trainer</code> class on initialization.All bnb optimizers are supported by passing the correct string in <code>TrainingArguments</code>’s <code>optim</code> attribute - e.g. (<code>paged_adamw_32bit</code>).",ee,M,he='See the <a href="https://huggingface.co/docs/transformers/main_classes/trainer#transformers.Trainer" rel="nofollow">official API docs for reference</a>.',te,C,ge=`Here we point out to relevant doc sections in transformers / peft / Trainer + very briefly explain how these are integrated:
e.g. for transformers state that you can load any model in 8-bit / 4-bit precision, for PEFT, you can use QLoRA out of the box with <code>LoraConfig</code> + 4-bit base model, for Trainer: all bnb optimizers are supported by passing the correct string in <code>TrainingArguments</code>’s <code>optim</code> attribute - e.g. (<code>paged_adamw_32bit</code>):`,ie,H,ae,x,ye='<li><a href="https://huggingface.co/blog/4bit-transformers-bitsandbytes" rel="nofollow">Making LLMs even more accessible with bitsandbytes, 4-bit quantization and QLoRA</a></li> <li><a href="https://huggingface.co/blog/hf-bitsandbytes-integration" rel="nofollow">A Gentle Introduction to 8-bit Matrix Multiplication for transformers at scale using Hugging Face Transformers, Accelerate and bitsandbytes</a></li>',ne,E,se;return p=new k({props:{title:"Transformers",local:"transformers",headingTag:"h1"}}),u=new k({props:{title:"Beware: bf16 is optional compute data type",local:"beware-bf16-is-optional-compute-data-type",headingTag:"h2"}}),h=new xe({props:{code:"aW1wb3J0JTIwdG9yY2glMEFmcm9tJTIwdHJhbnNmb3JtZXJzJTIwaW1wb3J0JTIwQml0c0FuZEJ5dGVzQ29uZmlnJTBBJTBBcXVhbnRpemF0aW9uX2NvbmZpZyUyMCUzRCUyMEJpdHNBbmRCeXRlc0NvbmZpZyhsb2FkX2luXzRiaXQlM0RUcnVlJTJDJTIwYm5iXzRiaXRfY29tcHV0ZV9kdHlwZSUzRHRvcmNoLmJmbG9hdDE2KQ==",highlighted:`<span class="hljs-keyword">import</span> torch
<span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> BitsAndBytesConfig

quantization_config = BitsAndBytesConfig(load_in_4bit=<span class="hljs-literal">True</span>, bnb_4bit_compute_dtype=torch.bfloat16)`,wrap:!1}}),g=new k({props:{title:"PEFT",local:"peft",headingTag:"h1"}}),w=new k({props:{title:"Accelerate",local:"accelerate",headingTag:"h1"}}),v=new k({props:{title:"Trainer for the optimizers",local:"trainer-for-the-optimizers",headingTag:"h1"}}),H=new k({props:{title:"Blog posts",local:"blog-posts",headingTag:"h1"}}),{c(){f=o("meta"),X=n(),q=o("p"),Z=n(),P(p.$$.fragment),F=n(),m=o("p"),m.textContent=le,I=n(),c=o("p"),c.innerHTML=re,j=n(),d=o("p"),d.innerHTML=fe,Q=n(),P(u.$$.fragment),U=n(),b=o("p"),b.innerHTML=pe,N=n(),P(h.$$.fragment),S=n(),P(g.$$.fragment),V=n(),y=o("p"),y.innerHTML=me,W=n(),$=o("p"),$.innerHTML=ce,G=n(),P(w.$$.fragment),Y=n(),T=o("p"),T.textContent=de,D=n(),_=o("p"),_.innerHTML=ue,K=n(),P(v.$$.fragment),O=n(),L=o("p"),L.innerHTML=be,ee=n(),M=o("p"),M.innerHTML=he,te=n(),C=o("p"),C.innerHTML=ge,ie=n(),P(H.$$.fragment),ae=n(),x=o("ul"),x.innerHTML=ye,ne=n(),E=o("p"),this.h()},l(e){const t=Ce("svelte-u9bgzb",document.head);f=l(t,"META",{name:!0,content:!0}),t.forEach(i),X=s(e),q=l(e,"P",{}),$e(q).forEach(i),Z=s(e),z(p.$$.fragment,e),F=s(e),m=l(e,"P",{"data-svelte-h":!0}),r(m)!=="svelte-umvy4"&&(m.textContent=le),I=s(e),c=l(e,"P",{"data-svelte-h":!0}),r(c)!=="svelte-dleetj"&&(c.innerHTML=re),j=s(e),d=l(e,"P",{"data-svelte-h":!0}),r(d)!=="svelte-1peqy09"&&(d.innerHTML=fe),Q=s(e),z(u.$$.fragment,e),U=s(e),b=l(e,"P",{"data-svelte-h":!0}),r(b)!=="svelte-q0cjog"&&(b.innerHTML=pe),N=s(e),z(h.$$.fragment,e),S=s(e),z(g.$$.fragment,e),V=s(e),y=l(e,"P",{"data-svelte-h":!0}),r(y)!=="svelte-1pzo32b"&&(y.innerHTML=me),W=s(e),$=l(e,"P",{"data-svelte-h":!0}),r($)!=="svelte-ss69sb"&&($.innerHTML=ce),G=s(e),z(w.$$.fragment,e),Y=s(e),T=l(e,"P",{"data-svelte-h":!0}),r(T)!=="svelte-yklqdi"&&(T.textContent=de),D=s(e),_=l(e,"P",{"data-svelte-h":!0}),r(_)!=="svelte-f0p65c"&&(_.innerHTML=ue),K=s(e),z(v.$$.fragment,e),O=s(e),L=l(e,"P",{"data-svelte-h":!0}),r(L)!=="svelte-1lta7zi"&&(L.innerHTML=be),ee=s(e),M=l(e,"P",{"data-svelte-h":!0}),r(M)!=="svelte-l324p4"&&(M.innerHTML=he),te=s(e),C=l(e,"P",{"data-svelte-h":!0}),r(C)!=="svelte-1auupce"&&(C.innerHTML=ge),ie=s(e),z(H.$$.fragment,e),ae=s(e),x=l(e,"UL",{"data-svelte-h":!0}),r(x)!=="svelte-1opwyey"&&(x.innerHTML=ye),ne=s(e),E=l(e,"P",{}),$e(E).forEach(i),this.h()},h(){we(f,"name","hf:doc:metadata"),we(f,"content",ze)},m(e,t){He(document.head,f),a(e,X,t),a(e,q,t),a(e,Z,t),A(p,e,t),a(e,F,t),a(e,m,t),a(e,I,t),a(e,c,t),a(e,j,t),a(e,d,t),a(e,Q,t),A(u,e,t),a(e,U,t),a(e,b,t),a(e,N,t),A(h,e,t),a(e,S,t),A(g,e,t),a(e,V,t),a(e,y,t),a(e,W,t),a(e,$,t),a(e,G,t),A(w,e,t),a(e,Y,t),a(e,T,t),a(e,D,t),a(e,_,t),a(e,K,t),A(v,e,t),a(e,O,t),a(e,L,t),a(e,ee,t),a(e,M,t),a(e,te,t),a(e,C,t),a(e,ie,t),A(H,e,t),a(e,ae,t),a(e,x,t),a(e,ne,t),a(e,E,t),se=!0},p:_e,i(e){se||(B(p.$$.fragment,e),B(u.$$.fragment,e),B(h.$$.fragment,e),B(g.$$.fragment,e),B(w.$$.fragment,e),B(v.$$.fragment,e),B(H.$$.fragment,e),se=!0)},o(e){J(p.$$.fragment,e),J(u.$$.fragment,e),J(h.$$.fragment,e),J(g.$$.fragment,e),J(w.$$.fragment,e),J(v.$$.fragment,e),J(H.$$.fragment,e),se=!1},d(e){e&&(i(X),i(q),i(Z),i(F),i(m),i(I),i(c),i(j),i(d),i(Q),i(U),i(b),i(N),i(S),i(V),i(y),i(W),i($),i(G),i(Y),i(T),i(D),i(_),i(K),i(O),i(L),i(ee),i(M),i(te),i(C),i(ie),i(ae),i(x),i(ne),i(E)),i(f),R(p,e),R(u,e),R(h,e),R(g,e),R(w,e),R(v,e),R(H,e)}}}const ze='{"title":"Transformers","local":"transformers","sections":[{"title":"Beware: bf16 is optional compute data type","local":"beware-bf16-is-optional-compute-data-type","sections":[],"depth":2}],"depth":1}';function Ae(oe){return ve(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class qe extends Le{constructor(f){super(),Me(this,f,Ae,Pe,Te,{})}}export{qe as component};
